<template>
	<a-card :bordered="false">
		<a-form ref="searchFormRef" name="advanced_search" :model="searchFormState" class="ant-advanced-search-form mb-4">
			<a-row :gutter="24">
				<a-col :span="4">
					<a-form-item label="企业客户" name="depotId">
						<a-select v-model:value="searchFormState.depotId" placeholder="请选择企业客户" :options="depotOptions"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-form-item label="类型" name="billGroup">
						<a-select v-model:value="searchFormState.billGroup" placeholder="请选择类型" :options="billGroupOptions"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-form-item label="出入库" name="depotBizType">
						<a-select v-model:value="searchFormState.depotBizType" placeholder="请选择出入库" :options="depotBizTypeOptions"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-form-item label="预约编号" name="truckBookId">
						<a-input v-model:value="searchFormState.truckBookId" placeholder="请输入预约编号"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-form-item label="车牌号码" name="licensePlate">
						<a-input v-model:value="searchFormState.licensePlate" placeholder="请输入车牌号码"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-button type="primary" @click="table.refresh(true)">查询</a-button>
					<a-button style="margin: 0 8px" @click="() => searchFormRef.resetFields()">重置</a-button>
					<a @click="toggleAdvanced" style="margin-left: 8px">
						{{ advanced ? '收起' : '展开' }}
						<component :is="advanced ? 'up-outlined' : 'down-outlined'"/>
					</a>
				</a-col>
				<template v-if="advanced">
					<a-col :span="4">
						<a-form-item label="司机姓名" name="driverName">
							<a-input v-model:value="searchFormState.driverName" placeholder="请输入司机姓名"/>
						</a-form-item>
					</a-col>
				</template>
				<template v-if="advanced">
					<a-col :span="4">
						<a-form-item label="司机电话" name="driverMobile">
							<a-input v-model:value="searchFormState.driverMobile" placeholder="请输入司机电话"/>
						</a-form-item>
					</a-col>
				</template>
				<template v-if="advanced">
					<a-col :span="4">
						<a-form-item label="车牌颜色" name="plateColor">
							<a-select v-model:value="searchFormState.plateColor" placeholder="请选择车牌颜色" :options="plateColorOptions"/>
						</a-form-item>
					</a-col>
				</template>
			</a-row>
		</a-form>
		<s-table
			ref="table"
			:columns="columns"
			:data="loadData"
			:alert="options.alert.show"
			bordered
			:row-key="(record) => record.id"
			:tool-config="toolConfig"
			:row-selection="options.rowSelection"
		>
			<template #operator class="table-operator">
				<a-space>
					<!--					<a-button type="primary" @click="plugFormRef.onOpen()" v-if="hasPerm('depotOpApprovalState')">
											<template #icon>
												<plus-outlined/>
											</template>
											补单
										</a-button>-->
					<a-button type="primary" @click="exportTable()"><export-outlined/>导出</a-button>
					<a-button danger @click="deleteBatchDepotTruckWeighDouble()" v-if="hasPerm('depotTruckWeighDoubleBatchDelete')">删除</a-button>
				</a-space>
			</template>
			<template #bodyCell="{ column, record }">
				<template v-if="column.dataIndex === 'action'">
					<a-space>
						<a-button type="link" size="small" @click="detailFormRef.onOpen(record)">
							详情
						</a-button>
						<!--					<a @click="detailFormRef.onOpen(record)"
										   v-if="hasPerm('depotTruckWeighDoubleEdit')">
											<a-divider type="vertical"/>
											编辑
										</a>-->
						<a-popconfirm title="确定要删除吗？" @confirm="deleteDepotTruckWeighDouble(record)">
							<a-button type="link" danger size="small" v-if="hasPerm('depotTruckWeighDoubleDelete')">
								删除
							</a-button>
						</a-popconfirm>
					</a-space>
				</template>
			</template>
		</s-table>
	</a-card>
	<Form ref="formRef" @successful="table.refresh(true)"/>
	<DetailForm ref="detailFormRef"/>
</template>

<script setup name="depotTruckWeighDouble">
import {message} from 'ant-design-vue'
import tool from '@/utils/tool'
import Form from './form.vue'
import DetailForm from './detailForm.vue'
import depotTruckWeighDoubleApi from '@/api/biz/depotTruckWeighDoubleApi'
import dictOptionsApi from "@/api/biz/dictOptionsApi";
import * as XLSX from "xlsx";
import moment from "moment";

let searchFormState = reactive({})
const searchFormRef = ref()
const table = ref()
const formRef = ref()
const detailFormRef = ref()
const depotOptions = ref([])
const toolConfig = {refresh: true, height: true, columnSetting: true, striped: false}
// 查询区域显示更多控制
const advanced = ref(false)
const toggleAdvanced = () => {
	advanced.value = !advanced.value
}
const columns = [
	{
		title: '企业客户',
		dataIndex: 'depotGrainName'
	},
	{
		title: '预约编号',
		dataIndex: 'truckBookId'
	},
	{
		title: '单据分类',
		dataIndex: 'billGroup'
	},
	{
		title: '出入库',
		dataIndex: 'depotBizType'
	},
	{
		title: '车牌号码',
		dataIndex: 'licensePlate'
	},
	{
		title: '车牌颜色',
		dataIndex: 'plateColor'
	},
	{
		title: '过毛时间',
		dataIndex: 'grossTime'
	},
	{
		title: '过皮时间',
		dataIndex: 'tareTime'
	},
	{
		title: '毛重(公斤)',
		dataIndex: 'grossWeight'
	},
	{
		title: '皮重(公斤)',
		dataIndex: 'tareWeight'
	},
	{
		title: '净重(公斤)',
		dataIndex: 'netWeight'
	},
]
// 操作栏通过权限判断是否显示
//if (hasPerm(['depotTruckWeighDoubleEdit', 'depotTruckWeighDoubleDelete', '审批人工补单'])) {
columns.push({
	title: '操作',
	dataIndex: 'action',
	align: 'center',
	width: '100px'
})
//}
let selectedRowKeys = ref([])
// 列表选择配置
const options = {
	alert: {
		show: false,
		clear: () => {
			selectedRowKeys = ref([])
		}
	},
	rowSelection: {
		onChange: (selectedRowKey, selectedRows) => {
			selectedRowKeys.value = selectedRowKey
		}
	}
}
dictOptionsApi.options(Object.assign('', {'dictValue': '粮库'})).then((data) => {
	depotOptions.value = data
})
let loadDataLst
const loadData = (parameter) => {
	const searchFormParam = JSON.parse(JSON.stringify(searchFormState))
	return depotTruckWeighDoubleApi.depotTruckWeighDoublePage(Object.assign(parameter, searchFormParam)).then((data) => {
		loadDataLst = data.records
		return data
	})
}
// 删除
const deleteDepotTruckWeighDouble = (record) => {
	let params = [
		{
			id: record.id
		}
	]
	depotTruckWeighDoubleApi.depotTruckWeighDoubleDelete(params).then(() => {
		table.value.refresh(true)
	})
}
// 批量删除
const deleteBatchDepotTruckWeighDouble = () => {
	if (selectedRowKeys.value.length < 1) {
		message.warning('请选择一条或多条数据')
		return false
	}
	const params = selectedRowKeys.value.map((m) => {
		return {
			id: m
		}
	})
	depotTruckWeighDoubleApi.depotTruckWeighDoubleDelete(params).then(() => {
		table.value.clearRefreshSelected()
	})
}
// 导出
const exportTable = () => {
	let tableData = [['企业客户', '预约编号', '出入库', '粮食种类', '粮食类型', '单据类型', '车牌号码', '车牌颜色', '司机姓名', '司机电话'
		, '过毛时间', '过皮时间', '毛重(公斤)', '皮重(公斤)', '净重(公斤)', '单价(元/吨)', '总价(元)']]
	let idStr = ''
	if (selectedRowKeys.value.length > 0) {
		selectedRowKeys.value.map((m) => {
			idStr = idStr + ',' + m
		})
	}
	loadDataLst.map((m) => {
		if (!idStr || idStr.indexOf(m.id) > 0)
			tableData.push([m.depotGrainName, m.truckBookId, m.depotBizType, m.grainGroup, m.grainType, m.billGroup, m.licensePlate, m.plateColor, m.driverName, m.driverMobile
				, m.grossTime, m.tareTime, m.grossWeight, m.tareWeight, m.netWeight, m.unitPrice, m.totalPrice])
	})
	let workSheet = XLSX.utils.aoa_to_sheet(tableData)
	let bookNew = XLSX.utils.book_new()
	XLSX.utils.book_append_sheet(bookNew, workSheet, 'Sheet1')
	let name = '过磅记录' + moment().format('_YYYY-MM-DD') + '.xlsx'
	XLSX.writeFile(bookNew, name)
}
const depotBizTypeOptions = tool.dictList('出入库')
const billGroupOptions = tool.dictList('系统人工')
const plateColorOptions = tool.dictList('车牌颜色')
</script>
